<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\equity;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\equity\EquityOrder;
use app\common\lists\ListsSearchInterface;
use app\common\model\user\User;


/**
 * EquityOrder列表
 * Class EquityOrderLists
 * @package app\adminapi\lists
 */
class EquityOrderLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/12/25 13:32
     */
    public function setSearch(): array
    {
        if(isset($this->params['mobile']) && !empty($this->params['mobile'])){
            $userId = User::where('mobile',$this->params['mobile'])->value('id')??-1;
            $this->params['user_id'] = $userId;
        }
        return [
            '=' => ['user_id', 'description', 'price', 'create_order_time', 'service_work_id', 'equity_id', 'status', 'property_head_id', 'remark'],

        ];
    }


    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/12/25 13:32
     */
    public function lists(): array
    {
        return EquityOrder::with(['equityConfig','user','propertyHead','serviceWork'])->where($this->searchWhere)
            ->field(['id', 'user_id', 'description', 'price', 'create_order_time', 'service_work_id', 'equity_id', 'status', 'property_head_id', 'remark'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/12/25 13:32
     */
    public function count(): int
    {
        return EquityOrder::where($this->searchWhere)->count();
    }

}